#include <stdio.h>
#include <conio.h>
#include <BIOS.H>

int PRNJoyStick ( int prn ) {

  int state = 0, i = biosprint( 2, 0, prn);

  if      (!(i&16) ) state += 1;  /* FORWARD */
  else if (!(i&32) ) state += 2;  /* BACKWARD */

  if      ( i&128 ) state += 4;  /* LEFT */
  else if ( i& 64 ) state += 8;  /* RIGHT */

  return state;
}

int PRNJoyTrigger ( int prn ) {

  if ( (biosprint( 2, 0, prn))&8 )
    return 1;
  else
    return 0;
}

/******************
 *  Main function
 ******************/

int main ( void ) {

  int  prn = 0 , tst;
  char ch;

  clrscr();
  _setcursortype(_NOCURSOR);

  printf("LPT JoyStick tester by Petr Sumbera (March 22 1998)\n");
  printf("---------------------------------------------------\n\n");

  printf("This program is primary used for testing joysticks from\n");
  printf("ATARI/AMIGA computers conected to the PC through the PARALEL ");
  printf("ports.\n\n");
  printf("For more info see documentation or visit this sites:\n\n");
  printf("  http://www.stud.fee.vutbr.cz/~xsumbe00\n");
  printf("  http://www.sumbera.cyberstrider.org (mirror)\n\n");

  printf("PORT NUMBER: 1   ([P] for changing)\n\n");

  printf("Joystick status:\n");
  printf("----------------\n\n");

  printf(" BUTTON \n\n");
  printf("     UP \n");
  printf("   DOWN \n");
  printf("   LEFT \n");
  printf("  RIGHT \n\n");

  printf("Press SPACEBAR for exit.");

  while (1) {

    /* testing button */

    gotoxy(9,17);
    if (PRNJoyTrigger(prn))
      putchar('*');
    else
      putchar(' ');


    /* testing stick position */

    tst = PRNJoyStick(prn);

    gotoxy(9,19);                            /* UP */
    if (tst == 1 || tst == 5 || tst == 9)
      putchar('*');
    else
      putchar(' ');

    gotoxy(9,20);                            /* DOWN */
    if (tst == 2 || tst == 6 || tst == 10)
      putchar('*');
    else
      putchar(' ');

    gotoxy(9,21);                            /* LEFT */
    if (tst == 4 || tst == 5 || tst == 6)
      putchar('*');
    else
      putchar(' ');

    gotoxy(9,22);                            /* RIGHT */
    if (tst == 8 || tst == 9 || tst == 10)
      putchar('*');
    else
      putchar(' ');

    /* testing keyboard strikes */

    if (kbhit()) {
      ch = getch();

      if (ch == ' ') break;

      else if (ch =='P' || ch == 'p') {
        prn++;
        prn = prn % 4;
        gotoxy(14,12);
        printf("%d",prn+1);
      }
    }
  } /* end of while(1) */

  return 0;
}